
#include "xfer-spaces.h"
#include <stdlib.h>

typedef struct MyObject {
  const char* name;
  unsigned data_size;
} MyObject;

static MyObject* my_object_new(const char* name, unsigned data_size)
{
  MyObject* retv = (MyObject*)malloc(sizeof(MyObject));
  retv->name = name;
  retv->data_size = data_size;
  return retv;
}

static const char* my_get_name(void* opaque)
{
  return ((MyObject*)opaque)->name;
}

static unsigned my_get_data_size(void* opaque)
{
  return ((MyObject*)opaque)->data_size;
}

Debuggable my_object = {
  .get_name = my_get_name,
  .get_data_size = my_get_data_size,
  .read_data = 0,
  .write_data = 0
};

int main(int argc, char** argv)
{
  xfer_spaces_declare_object(&my_object, my_object_new("top.dma.reg0", 4));
  xfer_spaces_declare_object(&my_object, my_object_new("top.dma.reg1", 4));
  xfer_spaces_declare_object(&my_object, my_object_new("top.eth.regA", 2));
  xfer_spaces_declare_object(&my_object, my_object_new("top.eth.regB", 2));

  xfer_spaces_declare_object(&my_object, my_object_new("top1.dma.reg0", 4));
  xfer_spaces_declare_object(&my_object, my_object_new("top1.dma.reg1", 4));
  xfer_spaces_declare_object(&my_object, my_object_new("top1.eth.regA", 2));
  xfer_spaces_declare_object(&my_object, my_object_new("top1.eth.regB", 2));

  xfer_spaces_elaborate();
  xfer_spaces_print_tree();
  xfer_spaces_dump_xml(stdout, "hw", "hw");
  
  return 0;
}
